<?php

class Pi_Edd_Menu{

    public $plugin_name;
    public $menu;
    
    function __construct($plugin_name , $version){
        $this->plugin_name = $plugin_name;
        $this->version = $version;
        add_action( 'admin_menu', array($this,'plugin_menu') );
        add_action($this->plugin_name.'_promotion', array($this,'promotion'));
        add_action('admin_notices', array($this, 'criticalNotice'));
    }

    function criticalNotice(){
        $default_zone_id = get_option('pi_defaul_shipping_zone',0);
        if($default_zone_id == "" || $default_zone_id == 0 ){
            echo "<div class='notice notice-error is-dismissible'>
                        <h3>Estimate delivery date for WooCommerce Pro</h3>
                        <p>You must select a <strong>Default shipping Zone</strong>, without this you wont see any estimated shipping date on the website </p>
                        <p>Go to <a href='".admin_url("admin.php?page=pi-edd")."'>Plugin Settings</a> to correct this</p>
                        </div>";
        }

        if(!pisol_checking::checkZones()){
            echo "<div class='notice notice-error is-dismissible'>
                        <h3>Estimate delivery date for Woocommerce Pro</h3>
                        <p>You must have shipping zones to use this setting, so create shipping zone in WooCommerce <a href='".admin_url("admin.php?page=wc-settings&tab=shipping")."'>Click here to set shipping zone</p>
                </div>";
        }
    }

    function plugin_menu(){
        
        $this->menu = add_submenu_page(
            'woocommerce',
            __( 'Estimate Date', 'pi-edd' ),
            'Estimate delivery date',
            'manage_options',
            'pi-edd',
            array($this, 'menu_option_page'),
            6
        );

        add_action("load-".$this->menu, array($this,"bootstrap_style"));
 
    }

    public function bootstrap_style() {

		wp_enqueue_style( $this->plugin_name."_bootstrap", plugin_dir_url( __FILE__ ) . 'css/bootstrap.css', array(), $this->version, 'all' );
        wp_enqueue_style( $this->plugin_name."_calender", plugin_dir_url( __FILE__ ) . 'css/jquery-ui.multidatespicker.css', array(), $this->version, 'all' );
        wp_enqueue_script( $this->plugin_name."_calender", plugin_dir_url( __FILE__ ) . 'js/jquery-ui.multidatespicker.js', array('jquery','jquery-ui-core','jquery-ui-datepicker'), $this->version );
        wp_enqueue_script( $this->plugin_name."_jsrender", plugin_dir_url( __FILE__ ) . 'js/jsrender.min.js', array('jquery'), $this->version );
        wp_enqueue_script( $this->plugin_name."_translate", plugin_dir_url( __FILE__ ) . 'js/pisol-translate.js', array('jquery',$this->plugin_name."_jsrender"), $this->version );

        /* 4/7/19 */
        wp_enqueue_script( $this->plugin_name."_shipping", plugin_dir_url( __FILE__ ) . 'js/pisol-shipping.js', array('jquery',$this->plugin_name."_jsrender"), $this->version );
        /* 4/7/19 */
        
        wp_enqueue_style($this->plugin_name."_timepicker", plugin_dir_url( __FILE__ ) . 'css/jquery.timepicker.min.css');
        wp_enqueue_script( $this->plugin_name."_timepicker", plugin_dir_url( __FILE__ ) . 'js/jquery.timepicker.min.js', array('jquery'), $this->version );
        $time_picker = '
            jQuery(document).ready(function($){

                function clearValue(id) {
                    $("<a class=\'pi-clear-value btn btn-danger text-light\'>Clear Value</a>").insertAfter("#" + id);
                }

                clearValue("pi_shipping_breakup_time");

                $(".pi-clear-value").on("click", function () {
                    $("input", $(this).parent()).val("");
                  });

                $("#pi_shipping_breakup_time").attr("readonly","readonly");
                $("#pi_shipping_breakup_time").timepicker({ "timeFormat": "H:mm",interval: 15 });
            });
        ';
        wp_add_inline_script($this->plugin_name."_timepicker", $time_picker, 'after');

        wp_enqueue_style('jquery-ui', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css');
        $calender = '
            jQuery(document).ready(function($){
                var saved_dates = $("#pi_edd_holidays").val();
                saved_dates = ((saved_dates != undefined && saved_dates != "") ? saved_dates.split(":") : ["1997/01/01"]);
                console.log(saved_dates);
                $("#pi-holiday-calender").multiDatesPicker({
                    dateFormat: "yy/mm/dd",
                    separator: ":",
                    onSelect: function(date){
                        var dates = $("#pi-holiday-calender").multiDatesPicker("getDates");
                        dates = dates.toString();
                        $("#pi_edd_holidays").val(dates.replace(/,/g, ":"));
                        pi_show_selected_dates();
                    },
                    addDates: saved_dates
                });

                $("#reset-holidays").click(function(){
                    $("#pi_edd_holidays").val("");
                    $("#pi-holiday-calender").multiDatesPicker("resetDates");
                    pi_show_selected_dates();
                });

                pi_show_selected_dates();
               

                function pi_show_selected_dates(){
                    var saved_dates = $("#pi_edd_holidays").val();
                    var dates = ((saved_dates != undefined && saved_dates != "") ? saved_dates.split(":") : [])
                    dates = dates.map(function(date){ 
                        if(date != "1997/01/01"){
                            date = new Date(date);
                        return "<span class=\"bg-secondary py-2 px-3 text-light d-block font-weight-bold m-2\">"+date.toLocaleDateString("en-US")+"</span>"; 
                        }
                    });
                    $("#pi-selected-holidays").html(dates);
                }

            });
        ';
        wp_add_inline_script($this->plugin_name."_calender", $calender, 'after');

	}

    function menu_option_page(){
        ?>
        <div class="container mt-2">
            <div class="row">
                    <div class="col-12">
                        <div class='bg-dark'>
                        <div class="row">
                            <div class="col-12 col-sm-2 py-2">
                                    <a href="https://www.piwebsolution.com/" target="_blank"><img class="img-fluid ml-2" src="<?php echo plugin_dir_url( __FILE__ ); ?>img/pi-web-solution.png"></a>
                            </div>
                            <div class="col-12 col-sm-10 d-flex">
                                <?php do_action($this->plugin_name.'_tab'); ?>
                                <a class=" px-3 font-weight-bold text-light d-flex align-items-center  border-left border-right  bg-primary mr-0 ml-auto" href="https://www.piwebsolution.com/woocommerce-estimated-delivery-date-per-product/">
                                    User Guide
                                </a>
                            </div>
                        </div>
                        </div>
                    </div>
            </div>
            <div class="row">
                <div class="col-12">
                <div class="bg-light border pl-3 pr-3 pb-3 pt-0">
                    <div class="row">
                        <div class="col">
                        <?php do_action($this->plugin_name.'_tab_content'); ?>
                        </div>
                        <?php do_action($this->plugin_name.'_promotion'); ?>
                    </div>
                </div>
                </div>
            </div>
        </div>
        <?php
    }

    function promotion(){
        
    }

}