<?php

class Class_Pi_Edd_Option{

    public $plugin_name;

    private $setting = array();

    private $active_tab;

    private $this_tab = 'basic_setting';

    private $tab_name = "Basic setting";

    private $setting_key = 'basic_settting';

    private $shipping_zones =array();

    private $date_format = array(); 
    
   

    function __construct($plugin_name){
        $this->plugin_name = $plugin_name;

        $this->date_format = $this->date_format();
        
        $this->active_tab = (isset($_GET['tab'])) ? sanitize_text_field($_GET['tab']) : 'default';

        if($this->this_tab == $this->active_tab){
            add_action($this->plugin_name.'_tab_content', array($this,'tab_content'));
        }

        

        add_action($this->plugin_name.'_tab', array($this,'tab'),2);

        add_action('woocommerce_init', array($this,'shipping_zone_to_array'));
        
        
    }

    function shipping_zone_to_array(){
       // WC();
        $zones = WC_Shipping_Zones::get_zones();
        $this->shipping_zones = $this->zone_to_array($zones);
        
        
        $this->settings = array(
            array('field'=>'pi_edd_enable_estimate', 'label'=>__('Enable estimate','pi-edd'),'type'=>'switch', 'default'=> 1,   'desc'=>'Using this you can disable the estimate without disabling the plugin'),
            array('field'=>'pi_defaul_shipping_zone', 'label'=>__('Default shipping zone','pi-edd'),'type'=>'select', 'default'=> 0, 'value'=>$this->shipping_zones,  'desc'=>'This shipping zone will be used as default to calculate the estimated delivery time, till user select there shipping address'),
            array('field'=>'pi_general_range', 'label'=>__('Range of delivery date','pi-edd'),'type'=>'switch', 'default'=>0,   'desc'=>'Show a range of delivery date if you have more then one shipping class for that shipping zone (If the 2 dates in the range are coming same then it will show the single date estimate)'),
            array('field'=>'pi_edd_min_max', 'label'=>__('Show the best/worst estimate delivery time','pi-edd'),'type'=>'select', 'default'=>'max', 'value'=>array('min'=>'Best estimate', 'max'=>'Worst estimate'),  'desc'=>'Select the shipping method with minimum or maximum delivery time'),
            array('field'=>'pi_general_date_format', 'label'=>__('Date format','pi-edd'),'type'=>'select', 'default'=>'Y/m/d',   'desc'=>'Date format for the estimate date', 'value'=>$this->date_format),
            
            /*array('field'=>'pi_estimate_in_order_detail', 'label'=>__('Show estimated date in order detail','pi-edd'),'type'=>'switch', 'default'=>0,   'desc'=>'Show estimated date range in order detail, order email'),*/
            array('field'=>'pi_shipping_breakup_time', 'label'=>__('Last shipping time of the day (order coming after this time will be shipped next date)','pi-edd'),'type'=>'text', 'desc'=>'If the order is placed before this time then you can ship the product today, and so today will be counted in calculating the estimate, and if the order is placed after this time then the shipping can be done next date, so today will not be counted for estimate calculation, if you leave this blank counting will be done from next date'),
            array('field'=>'pi_days_of_week'),
        );
        $this->register_settings();
        
        if(PISOL_EDD_DELETE_SETTING){
            $this->delete_settings();
        }
    }

    
    function delete_settings(){
        foreach($this->settings as $setting){
            delete_option( $setting['field'] );
        }
    }

    function zone_to_array($zones){
        $select[0] = "Select shipping zone";
        foreach($zones as $zone){
            $zone_obj = new WC_Shipping_Zone($zone['zone_id']);
            $methods = $zone_obj->get_shipping_methods(true);
            if(count($methods) > 0){
                $select[$zone['zone_id']] =  $zone['zone_name'];
            }
        }
        return $select;
    }


    function register_settings(){   

        foreach($this->settings as $setting){
            register_setting( $this->setting_key, $setting['field']);
        }
    
    }

    function tab(){
        ?>
        <a class=" px-3 text-light d-flex align-items-center  border-left border-right  <?php echo ($this->active_tab == $this->this_tab ? 'bg-primary' : 'bg-secondary'); ?>" href="<?php echo admin_url( 'admin.php?page='.sanitize_text_field($_GET['page']).'&tab='.$this->this_tab ); ?>">
            <?php _e( $this->tab_name, 'http2-push-content' ); ?> 
        </a>
        <?php
    }

    function tab_content(){
        if(count($this->shipping_zones) <= 1){
            echo '<div class="alert alert-primary mt-2">You must have shipping zones to use this setting, so create shipping zone in WooCommerce <a href="'.admin_url("admin.php?page=wc-settings&tab=shipping").'">Click here to set shipping zone</div>';
            return;
        }
       ?>
        <form method="post" action="options.php"  class="pisol-setting-form">
        <?php settings_fields( $this->setting_key ); ?>
        <?php $pi_days_of_week = get_option("pi_days_of_week",array()); 
        $pi_days_of_week = is_array($pi_days_of_week) ? $pi_days_of_week : array();
        ?>
        <?php
            foreach($this->settings as $setting){
                new pisol_class_form_edd($setting, $this->setting_key);
            }
        ?>
        <div class="row py-4 border-bottom align-items-center bg-primary text-light">
            <div class="col-12">
            <h2 class="mt-0 mb-0 text-light font-weight-light h5">Select days to skip in counting of holidays <br>(most shipping don't work on weekends so you can select Saturday, Sunday and all the saturday and sundays will not be counted in calculating estimated shipping date)</h2>
            </div>
        </div>
        <div class="row py-4 border-bottom align-items-center ">
            <div class="col-12 col-md-5">
                <label class="h6 mb-0" for="pi_days_of_week">Select days of week when your shipping is closed:</label>
            </div>
            <div class="col-12 col-md-7">
                <select name="pi_days_of_week[]" id="pi_days_of_week" class="form-control" multiple="multiple">
                    <option value="1" <?php echo (in_array(1, $pi_days_of_week) ? ' selected="selected" ': ''); ?>>Monday</option>
                    <option value="2" <?php echo (in_array(2, $pi_days_of_week) ? ' selected="selected" ': ''); ?>>Tuesday</option>
                    <option value="3" <?php echo (in_array(3, $pi_days_of_week) ? ' selected="selected" ': ''); ?>>Wednesday</option>
                    <option value="4" <?php echo (in_array(4, $pi_days_of_week) ? ' selected="selected" ': ''); ?>>Thursday</option>
                    <option value="5" <?php echo (in_array(5, $pi_days_of_week) ? ' selected="selected" ': ''); ?>>Friday</option>
                    <option value="6" <?php echo (in_array(6, $pi_days_of_week) ? ' selected="selected" ': ''); ?>>Saturday</option>
                    <option value="7" <?php echo (in_array(7, $pi_days_of_week) ? ' selected="selected" ': ''); ?>>Sunday</option>
                </select>
            </div>
        </div>
        <input type="submit" class="mt-3 btn btn-primary btn-sm" value="Save Option" />
        </form>
       <?php
    }

    function date_format(){
        $date = array();
        $date['Y/m/d'] = date('Y/m/d'); 
        $date['d/m/Y'] = date('d/m/Y');
        $date['m/d/y'] = date('m/d/y');
        $date['Y-m-d'] = date('Y-m-d'); 
        $date['d-m-Y'] = date('d-m-Y');
        $date['m-d-y'] = date('m-d-y');
        $date['Y.m.d'] = date('Y.m.d'); 
        $date['d.m.Y'] = date('d.m.Y');
        $date['m.d.y'] = date('m.d.y');
        $date["M j, Y"] = date("M j, Y");
        $date["jS F"] = date("jS F");
        $date["j. F"] = date("j. F");
        $date["j F"] = date("j F");
        $date["l j. F"] = date("l j. F");
        $date["l, F j"] = date("l, F j");
        $date["l j F"] = date("l j F");
        $date["F jS"] = date("F jS");
        $date["jS M"] = date("jS M");
        $date["M jS"] = date("M jS");
        return $date;
    }
}

new Class_Pi_Edd_Option($this->plugin_name);